# MySQL dump 8.13
#
# Host: localhost    Database: webtracker
#--------------------------------------------------------
# Server version	3.23.36

#
# Table structure for table 'CLICKS'
#

CREATE TABLE CLICKS (
  CLICK_ID mediumint(9) NOT NULL auto_increment,
  SEARCH_ENGINE_ID mediumint(9) default NULL,
  TRACKER_ID mediumint(9) default NULL,
  CLICK_DATE datetime default NULL,
  REFERER_URL varchar(255) default NULL,
  URL_NUM tinyint(4) default NULL,
  IP1 tinyint(3) unsigned default NULL,
  IP2 tinyint(3) unsigned default NULL,
  IP3 tinyint(3) unsigned default NULL,
  IP4 tinyint(3) unsigned default NULL,
  IP5 tinyint(3) unsigned default NULL,
  IP6 tinyint(3) unsigned default NULL,
  BROWSER_TYPE varchar(50) default NULL,
  PRIMARY KEY  (CLICK_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'CLICKS'
#

#
# Table structure for table 'CODES'
#

CREATE TABLE CODES (
  CODE_ID mediumint(9) NOT NULL auto_increment,
  CODE_TYPE int(11) default NULL,
  VALUE varchar(255) default NULL,
  ORDER_NUM smallint(6) default NULL,
  PRIMARY KEY  (CODE_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'CODES'
#

INSERT INTO CODES VALUES (1,0,'Tracker Type',NULL);
INSERT INTO CODES VALUES (2,1,'Stat',NULL);
INSERT INTO CODES VALUES (3,1,'Web',NULL);
INSERT INTO CODES VALUES (4,1,'Link',NULL);
INSERT INTO CODES VALUES (5,1,'Affiliate',NULL);
INSERT INTO CODES VALUES (6,NULL,'Payment Types',NULL);
INSERT INTO CODES VALUES (7,6,'1-st tier affiliate',NULL);
INSERT INTO CODES VALUES (8,6,'2-nd tier affiliate',NULL);
INSERT INTO CODES VALUES (9,6,'money transfer',NULL);

#
# Table structure for table 'COMISSIONS'
#

CREATE TABLE COMISSIONS (
  COMISSION_ID mediumint(9) NOT NULL auto_increment,
  MEMBER_ID mediumint(9) default NULL,
  COMISSION_DATE date default NULL,
  PRO_MEMBER tinyint(4) default NULL,
  TIER tinyint(4) default NULL,
  AMOUNT decimal(6,2) default NULL,
  PAID_DATE date default NULL,
  REFERRAL_ID mediumint(9) default NULL,
  PRIMARY KEY  (COMISSION_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'COMISSIONS'
#


#
# Table structure for table 'EMAIL_BROADCAST'
#

CREATE TABLE EMAIL_BROADCAST (
  MAILING_ID mediumint(9) NOT NULL auto_increment,
  MAILING_DATE datetime default NULL,
  FREE tinyint(4) default NULL,
  PRO tinyint(4) default NULL,
  FROM_FIELD text,
  SUBJECT text,
  BODY text,
  SENT_EMAILS_NUMBER mediumint(9) default NULL,
  FINISHED_SUCCESSFULLY tinyint(4) default NULL,
  FAILED_EMAILS_NUMBER mediumint(9) default NULL,
  FINISHED_DATE datetime default NULL,
  PRIMARY KEY  (MAILING_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'EMAIL_BROADCAST'
#

#
# Table structure for table 'GLOBALS'
#

CREATE TABLE GLOBALS (
  NAME varchar(50) NOT NULL default '',
  VALUE varchar(255) default NULL,
  ORDER_NUM smallint(6) default '9999',
  PRIMARY KEY  (NAME)
) TYPE=MyISAM;

#
# Dumping data for table 'GLOBALS'
#

INSERT INTO GLOBALS VALUES ('ST_STAT_DAYS','30',60);
INSERT INTO GLOBALS VALUES ('ST_STAT_DAYS_PRO','60',60);
INSERT INTO GLOBALS VALUES ('ST_AD_STAT_DAYS','40',60);
INSERT INTO GLOBALS VALUES ('ST_AD_STAT_DAYS_PRO','80',60);
INSERT INTO GLOBALS VALUES ('AFFILIATE_COMISSION','0.5',60);
INSERT INTO GLOBALS VALUES ('AFFILIATE_COMISSION_PRO','0.7',60);
INSERT INTO GLOBALS VALUES ('2T_AFFILIATE_COMISSION','0.1',60);
INSERT INTO GLOBALS VALUES ('2T_AFFILIATE_COMISSION_PRO','0.2',60);
INSERT INTO GLOBALS VALUES ('ADMIN_LOGIN','admin',60);
INSERT INTO GLOBALS VALUES ('LAST_EXPIRED_REMOVE','2002-01-28 16:09:15',60);
INSERT INTO GLOBALS VALUES ('LAST_PAYMENT_UPDATE','2002-01-28 16:08:43',60);
INSERT INTO GLOBALS VALUES ('ADMIN_PASS','admin',60);

#
# Table structure for table 'MEMBERS'
#

CREATE TABLE MEMBERS (
  MEMBER_ID mediumint(9) NOT NULL auto_increment,
  LOGIN varchar(20) default NULL,
  PASSWORD varchar(20) default NULL,
  FIRST_NAME varchar(20) default NULL,
  LAST_NAME varchar(20) default NULL,
  ADDRESS varchar(100) default NULL,
  COUNTRY varchar(50) default NULL,
  CITY varchar(20) default NULL,
  STATE char(2) default NULL,
  ZIP varchar(20) default NULL,
  PHONE varchar(20) default NULL,
  E_MAIL varchar(60) default NULL,
  COMPANY varchar(20) default NULL,
  PRO_MEMBER_REG_DATE datetime default NULL,
  REFERER_ID mediumint(9) default NULL,
  SIGN_UP_DATE datetime default NULL,
  PRIMARY KEY  (MEMBER_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'MEMBERS'
#

#
# Table structure for table 'PAYMENTS'
#

CREATE TABLE PAYMENTS (
  PAYMENT_ID mediumint(9) NOT NULL auto_increment,
  PAYMENT_DATE datetime default NULL,
  PAYMENT_TYPE int(11) default NULL,
  TIER int(11) default NULL,
  ACCEPTOR_ID int(11) default NULL,
  REFERAL_ID int(11) default NULL,
  AMOUNT double(6,2) default NULL,
  UPDATED tinyint(4) default NULL,
  PRIMARY KEY  (PAYMENT_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'PAYMENTS'
#

#
# Table structure for table 'SALES'
#

CREATE TABLE SALES (
  SALE_ID int(11) NOT NULL auto_increment,
  CLICK_ID int(11) default NULL,
  SALE_DATE datetime default NULL,
  PRIMARY KEY  (SALE_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'SALES'
#

#
# Table structure for table 'SEARCH_ENGINES'
#

CREATE TABLE SEARCH_ENGINES (
  SEARCH_ENGINE_ID mediumint(9) NOT NULL auto_increment,
  NAME varchar(20) default NULL,
  URL_PART varchar(255) default NULL,
  SEARCH_STRING_START varchar(50) default NULL,
  PRIMARY KEY  (SEARCH_ENGINE_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'SEARCH_ENGINES'
#

INSERT INTO SEARCH_ENGINES VALUES (2,'Altavista','.altavista.','?q=\\\"\\\'');

#
# Table structure for table 'TRACKERS'
#

CREATE TABLE TRACKERS (
  TRACKER_ID mediumint(9) NOT NULL auto_increment,
  MEMBER_ID mediumint(9) default NULL,
  START_DATE date default NULL,
  END_DATE date default NULL,
  NAME varchar(20) default NULL,
  TYPE mediumint(9) default NULL,
  URL1 varchar(255) default NULL,
  URL2 varchar(255) default NULL,
  LAST_URL tinyint(4) default NULL,
  COST decimal(6,2) default NULL,
  PRIMARY KEY  (TRACKER_ID)
) TYPE=MyISAM;

#
# Dumping data for table 'TRACKERS'
#

