<?php
/*
 * Useful Functions
 *
 * OVR
 *
 */ 

$month_names = array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

function bind_params($query, $params) {
	$sql_parts = preg_split("/\?/", $query);
	$ret = $sql_parts[0];
	$i = 1;
	foreach ($params as $par_val)
	{
		$ret .= (empty($par_val) ? "NULL" : "'".mysql_escape_string($par_val)."'").$sql_parts[$i++];
	}
	return $ret;
}

function read_form_data(&$params, $method) {
	foreach (array_keys($params) as $par_val)
	{
		if (!$params[$par_val]["desc"])
		{
			$params[$par_val]["desc"] = ucfirst($par_val);
		}
		if ($method == "GET")
		{
			$params[$par_val]["value"] = $GLOBALS["HTTP_GET_VARS"][$par_val];
		} else
		{
			$params[$par_val]["value"] = $GLOBALS["HTTP_POST_VARS"][$par_val];
		}
	}
}


function get_data_for_set_var(&$params) {
	$ret = array();
	foreach (array_keys($params) as $par_val)
	{
		if ($params[$par_val]["template_var_name"])
		{
			$ret[$params[$par_val]["template_var_name"]] = html_encode_spec($params[$par_val]["value"]);
		} else
		{
			$ret[strtoupper($par_val)] = html_encode_spec($params[$par_val]["value"]);
		}
	}
	return $ret;
}

function validate_input(&$params) {
	$err = "";
	foreach (array_keys($params) as $par_val)
	{
		if ($params[$par_val]["no_overwrite_null"] && (!$params[$par_val]["value"] || $params[$par_val]["value"] == ""))
		{
			continue;
		}
		if ($params[$par_val]["min"] && $params[$par_val]["min"] > strlen($params[$par_val]["value"]))
		{
			$err .= $params[$par_val]["desc"] . " should be at least ".$params[$par_val]["min"]." characters long!<br>";
		}
		if ($params[$par_val]["required"] && !$params[$par_val]["value"])
		{
			$err .= $params[$par_val]["desc"] . " is reqired field!<br>";
		}
		if ($params[$par_val]["regexp"] && !(preg_match($params[$par_val]["regexp"], $params[$par_val]["value"])))
		{
			$err .= "Invalid " . $params[$par_val]["desc"] . "!<br>";
		}
	}
	return $err;
}

function get_insert_query(&$params, $table_name) {
	$values = array();
	$fields = array();
	foreach (array_keys($params) as $par_val)
	{
		if (!$params[$par_val]["no_insert"])
		{
			if ($params[$par_val]["db_field"])
			{
				array_push($fields, $params[$par_val]["db_field"]);
			} else
			{
				array_push($fields, strtoupper($par_val));
			}
			
			if ($params[$par_val]["null"] && (!$params[$par_val]["value"] || $params[$par_val]["value"] == ""))
			{
				array_push($values, "NULL");
			} else
			{
				array_push($values, "'".mysql_escape_string($params[$par_val]["value"])."'");
			}
		}
	}
	
	$query = "insert into $table_name (" . join(",", $fields) . ") values (" . join(",", $values) . ")";
	return $query;
}

function get_select_query(&$params, $table_name, $conditions) {
	$values = array();
	$fields = array();
	foreach (array_keys($params) as $par_val)
	{
		if (!$params[$par_val]["no_select"])
		{
			if ($params[$par_val]["db_field"])
			{
				array_push($fields, $params[$par_val]["db_field"]);
			} else
			{
				array_push($fields, strtoupper($par_val));
			}
		}
	}
	
	$query = "select " . join(",", $fields) . " from $table_name";
	if ($conditions)
	{
		$query .= " where ".$conditions;
	}
	return $query;
}

function get_update_query(&$params, $table_name, $conditions) {
	$query = "update $table_name set ";
	
	foreach (array_keys($params) as $par_val)
	{
		if (!$params[$par_val]["no_update"] && (!$params[$par_val]["no_overwrite_null"] || $params[$par_val]["value"]))
		{
			if ($params[$par_val]["db_field"])
			{
				$query .= $params[$par_val]["db_field"];
			} else
			{
				$query .= strtoupper($par_val);
			}
			
			$query .= "=";
			
			if ($params[$par_val]["null"] && (!$params[$par_val]["value"] || $params[$par_val]["value"] == ""))
			{
				$query .= "NULL";
			} else
			{
				$query .= "'".mysql_escape_string($params[$par_val]["value"])."'";
			}
			
			$query .= ",";
		}
	}
	$query = substr($query, 0, strlen($query) - 1);	
	
	if ($conditions)
	{
		$query .= " where $conditions";
	}

	return $query;
}

function get_tracker_script_static($tracker_id)
{
	$res = '<script language="javascript"><!--'."\n".
		'dr = ""+escape(document.referrer);'."\n".
		'dt = new Date();'."\n".
		'rnd = dt.valueOf().toString().substring(7,20);'."\n".
		'document.write("<img src=\"'.BASE_URL.'member/track.php?tr='.$tracker_id.'&dr="+dr+"&"+rnd+"\" width=\"1\"  height=\"1\">");'."\n".
		'//-->\n</script>'."\n";
	return $res;
}

function get_tracker_script_dynamic()
{
	$res = '<script language="javascript"><!--'."\n".
		'url = document.URL + "&";'.
		'/(\&|\?)tid=(\d+)\&/.exec(url);'.
		'tid = RegExp.$2;'.
		'dr = ""+escape(document.referrer);'."\n".
		'dt = new Date();'."\n".
		'rnd = dt.valueOf().toString().substring(7,20);'."\n".
		'document.write("<img src=\"'.BASE_URL.'member/track.php?tr="+tid+"&dr="+dr+"&"+rnd+"\" width=\"1\"  height=\"1\">");'."\n".
		"//-->\n</script>";
	return $res;
}

function get_tracker_script_sales($tracker_id)
{
	$res = '<script language="javascript"><!--'."\n".
		'dr = ""+escape(document.referrer);'."\n".
		'dt = new Date();'."\n".
		'rnd = dt.valueOf().toString().substring(7,20);'."\n".
		'document.write("<img src=\"'.BASE_URL.'member/sales.php?tr='.$tracker_id.'"+"&"+rnd+"\" width=\"1\"  height=\"1\">");'."\n".
		'//-->\n</script>'."\n";
	return $res;
}

function get_tracker_script_sales_for_all($mid)
{
	$res = '<script language="javascript"><!--'."\n".
		'dr = ""+escape(document.referrer);'."\n".
		'dt = new Date();'."\n".
		'rnd = dt.valueOf().toString().substring(7,20);'."\n".
		'document.write("<img src=\"'.BASE_URL.'member/sales.php?mid='.$mid.'"+"&"+rnd+"\" width=\"1\"  height=\"1\">");'."\n".
		'//-->\n</script>'."\n";
	return $res;
}

function replace_empty($val, $repl)
{
	if ($val)
	{
		return $val;
	} else
	{
		return $repl;
	}
}

function get_tracker_info($tid)
{
	$query="SELECT * from TRACKERS where TRACKER_ID = $tid";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	$line = mysql_fetch_array($result);
	return $line;
}

function get_member_info($mid)
{
	$query="SELECT * from MEMBERS where MEMBER_ID = $mid";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	$line = mysql_fetch_array($result);
	return $line;
}

function update_se_keywords($tid)
{
	$query="SELECT SEARCH_ENGINE_ID,URL_PART,SEARCH_STRING_START from SEARCH_ENGINES";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	$data = array();
	while ($line = mysql_fetch_array($result))
	{
		$data[$line['SEARCH_ENGINE_ID']] = "/^[^\/]*".preg_quote($line['URL_PART']).".*".preg_quote($line['SEARCH_STRING_START'])."/i";
	}
	
	$query="SELECT CLICK_ID, REFERER_URL from CLICKS where SEARCH_ENGINE_ID is NULL";
	if ($tid)
	{
		$query .= " and TRACKER_ID = $tid";
	}
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	$update_data = array();
	while ($line = mysql_fetch_array($result))
	{
		$ref = $line['REFERER_URL'];
		$ref = preg_replace("/^http:\/\//i","",$ref);
		$match_id = 0;
		foreach (array_keys($data) as $id)
		{
			if (preg_match($data[$id],$ref))
			{
				$match_id = $id;
				break;
			}
		}
		$update_data[$match_id][$line["CLICK_ID"]] = 1;
	}
	foreach (array_keys($update_data) as $id)
	{
		$query = "update CLICKS set SEARCH_ENGINE_ID = $id where CLICK_ID in (".join(",",array_keys($update_data[$id])).")";
		mysql_query($query) or die ("invalid query: ".mysql_error());
	}
}

function get_year_options($selected)
{
	$ret = "";
	for ($i = 2002; $i <= 2010; $i++)
	{
		$ret .= "<option value='".($i)."'".($i == $selected ? " selected" : "").">".$i;
	}
	return $ret;
}

function get_month_options($selected)
{
	$ret = "";
	for ($i = 1; $i <= 12; $i++)
	{
		$ret .= "<option value='".($i < 10 ? "0$i" : $i)."'".($i == $selected ? " selected" : "").">".($GLOBALS['month_names'][$i-1]);
	}
	return $ret;
}

function get_day_options($selected)
{
	$ret = "";
	for ($i = 1; $i <= 31; $i++)
	{
		$ret .= "<option value='".($i < 10 ? "0$i" : $i)."'".($i == $selected ? " selected" : "").">".$i;
	}
	return $ret;
}

function init_affiliate_account($referal_id, $recurse_num, $initial_referal_id)
{
	$payment_type = array(2=>7, 1=>8);
	$query="SELECT REFERER_ID from MEMBERS where MEMBER_ID = $referal_id";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	if (($line = mysql_fetch_array($result)) && $line["REFERER_ID"])
	{
		$query = "insert PAYMENTS (PAYMENT_DATE, PAYMENT_TYPE, TIER, ACCEPTOR_ID, REFERAL_ID,AMOUNT) ".
			"values (now(), ".($payment_type[$recurse_num]).",".(3-$recurse_num).",".$line["REFERER_ID"].
			",$initial_referal_id,0)";
		mysql_query($query) or die ("invalid query: ".mysql_error());
		#$GLOBALS["WT_VARS"]["AFFILIATE_COMISSION"][

		if ($recurse_num > 1)
		{
			init_affiliate_account($line["REFERER_ID"], $recurse_num - 1,$initial_referal_id);
		}
		
	}
}

function load_globals($force_reload)
{
	if ($GLOBALS["WT_GLOBALS"] && $force_reload == 0)
	{
		return;
	}
	
	$GLOBALS["WT_GLOBALS"] = array();
	$query="SELECT NAME, VALUE from GLOBALS";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	while ($line = mysql_fetch_array($result))
	{
		$GLOBALS["WT_GLOBALS"][$line["NAME"]] = $line["VALUE"];
	}
}

# checks if a new monthly payment should be made
function update_payments()
{
	load_globals(0);

	# checking if we updated recently
	$query = "select VALUE + interval 20 minute < now() as CHK from GLOBALS where NAME = 'LAST_PAYMENT_UPDATE'";

	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	if ($line = mysql_fetch_array($result))
	{
		if ($line['CHK'] == 1)
		{
			$query = "update GLOBALS set VALUE = now() where NAME = 'LAST_PAYMENT_UPDATE'";
			$result=mysql_query($query) or die ("invalid query: ".mysql_error());
		}
		else
		{
			return;
		}
	} else
	{
		$query = "insert into GLOBALS (NAME, VALUE) values ('LAST_PAYMENT_UPDATE',now())";
		$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	}
	
	$query = "lock tables PAYMENTS write, PAYMENTS as a write, MEMBERS as b write, MEMBERS as c write";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	
	$query = "select PAYMENT_ID, PAYMENT_TYPE, PAYMENT_DATE, TIER, ACCEPTOR_ID, PAYMENT_TYPE, REFERAL_ID, b.PRO_MEMBER_REG_DATE from PAYMENTS a, MEMBERS b , MEMBERS c ".
		"where PAYMENT_TYPE in (7,8) and PAYMENT_DATE + interval 1 month < now() and a.ACCEPTOR_ID = b.MEMBER_ID and a.UPDATED is null ".
		"and a.REFERAL_ID = c.MEMBER_ID and c.PRO_MEMBER_REG_DATE is not null";
		
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());

	while ($line = mysql_fetch_array($result))
	{
		if ($line['PRO_MEMBER_REG_DATE'])
		{
			switch ($line['TIER'])
			{
				case 1:
					$amount = $GLOBALS["WT_GLOBALS"]["AFFILIATE_COMISSION_PRO"];
					break;
				case 2:
					$amount = $GLOBALS["WT_GLOBALS"]["2T_AFFILIATE_COMISSION_PRO"];
			}
		} else
		{
			switch ($line['TIER'])
			{
				case 1:
					$amount = $GLOBALS["WT_GLOBALS"]["AFFILIATE_COMISSION"];
					break;
				case 2:
					$amount = $GLOBALS["WT_GLOBALS"]["2T_AFFILIATE_COMISSION"];
			}
		}
		
		$query = "insert into PAYMENTS (PAYMENT_TYPE, PAYMENT_DATE, TIER, ACCEPTOR_ID, REFERAL_ID, AMOUNT) ".
			"values (".$line['PAYMENT_TYPE'].", '".$line['PAYMENT_DATE']."' + interval 1 month,".$line['TIER'].",".
			$line['ACCEPTOR_ID'].",".$line['REFERAL_ID'].",$amount)";
		mysql_query($query) or die ("invalid query: ".mysql_error());

		$query = "update PAYMENTS set UPDATED = 1 where PAYMENT_ID = ".$line["PAYMENT_ID"];
		mysql_query($query) or die ("invalid query: ".mysql_error());
	}
}

# removes expired logs
function delete_expired()
{
	load_globals(0);

	# checking if we removed data recently
	$query = "select VALUE + interval 1 hour < now() as CHK from GLOBALS where NAME = 'LAST_EXPIRED_REMOVE'";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	if ($line = mysql_fetch_array($result))
	{
		if (1 || $line['CHK'] == 1)
		{
			$query = "update GLOBALS set VALUE = now() where NAME = 'LAST_EXPIRED_REMOVE'";
			$result=mysql_query($query) or die ("invalid query: ".mysql_error());
		}
		else
		{
			return;
		}
	} else
	{
		$query = "insert into GLOBALS (NAME, VALUE) values ('LAST_EXPIRED_REMOVE',now())";
		$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	}
	
	$query = "select CLICK_ID from CLICKS a, TRACKERS b, MEMBERS c where a.TRACKER_ID = b.TRACKER_ID and b.MEMBER_ID = c.MEMBER_ID ".
		"and ((c.PRO_MEMBER_REG_DATE is null and ((b.TYPE = 2 and a.CLICK_DATE + interval ".$GLOBALS["WT_GLOBALS"]["ST_STAT_DAYS"]." day < now())) or ".
												"(b.TYPE > 2 and a.CLICK_DATE + interval ".$GLOBALS["WT_GLOBALS"]["ST_AD_STAT_DAYS"]." day < now())".
											   ")".
			" or (c.PRO_MEMBER_REG_DATE is not null and ((b.TYPE = 2 and a.CLICK_DATE + interval ".$GLOBALS["WT_GLOBALS"]["ST_STAT_DAYS_PRO"]." day < now()) or ".
												"(b.TYPE > 2 and a.CLICK_DATE + interval ".$GLOBALS["WT_GLOBALS"]["ST_AD_STAT_DAYS_PRO"]." day < now())".
											   ")))";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
	$ids = "-1";
	while ($line = mysql_fetch_array($result))
	{
		$ids .= ",".$line["CLICK_ID"];
	}

	$query = "delete from CLICKS where CLICK_ID in ($ids)";
	$result=mysql_query($query) or die ("invalid query: ".mysql_error());
}

function html_encode_spec($text)
{
	$text = str_replace("&",'&amp;',$text);
	$text = str_replace("\\",'&#092',$text);
	$trans = array('"' => "&quot;", "'" => '&#039', '<' => '&lt;', '>' => '&gt;');
	$text = strtr($text, $trans);
	#print "'/\\\\&\\#0".(48+$1).";/'";
	$text = preg_replace('/\$(\d)/e',"'\\\$&#0'.(48+'\\1').';'",$text);
	#$text = str_replace('$2','$&#50;',$text);
	return(($text));
}